
# ----------------------------------------
# MKP01 PROBLEM
# USING cover inequalities
# ----------------------------------------

set ITEM;
set Dimension;
param nCov integer >= 0, default 0;
set Covers := 1..nCov;
param profit {j in ITEM} integer > 0;
param capacity {i in Dimension} integer > 0;
param cardinality {i in Covers} integer > 0;

param weight {i in Dimension, j in ITEM} >= 0;
param nbr {Covers,ITEM} >= 0;

param Coverprofit {ITEM};   # profit for cover problem
param Coverweight {ITEM} >= 0;   # weight for cover problem
param Covercapacity >= 0;
var x {ITEM} integer >= 0 <= 1;           # item chosen

var u {ITEM} integer >= 0 <= 1;           # cover chosen

maximize TotalProfit:
   sum {j in ITEM} profit[j] * x[j];

subj to KnapsackCapacity {i in Dimension}:
   sum {j in ITEM} weight[i,j] * x[j] <= capacity[i];

subj to CoverIneq {i in Covers}:
   sum {j in ITEM} nbr[i,j] * x[j] <= cardinality[i];


maximize Cover:
   sum {j in ITEM} Coverprofit[j] * u[j];

subj to CoverDemand:
   sum {j in ITEM} Coverweight[j] * u[j] >= Covercapacity;

